// *************************************************************
//   Created with BCX -- The BASIC To C Translator (ver 2.69)
//        BCX (c) 1999, 2000, 2001 by Kevin Diggins
// *************************************************************

#include <windows.h>    // Win32 Header File
#include <commctrl.h>   // Win32 Header File
#include <stdlib.h>

// *************************************************
//                System Variables
// *************************************************

int   StrCnt;
LPSTR StrFunc [64];

// *************************************************
//            User Global Variables
// *************************************************

static  HINSTANCE BCX_hInstance;

static  int BCX_GetDiaUnit;
static  int BCX_cxBaseUnit;
static  int BCX_cyBaseUnit;
static  int BCX_ScaleX;
static  int BCX_ScaleY;

static  char   AppName [2048];

static  HWND  Form1;
static  HWND  Date1;
static  HWND  Butt1;
static  HWND  Edit1;

// *************************************************
//               Standard Macros
// *************************************************

#define Show(Window) ShowWindow(Window,SW_SHOW);

// *************************************************
//               Standard Prototypes
// *************************************************

void Center (HWND);
HWND Form(char*,int,int,int,int);
HWND Edit(char*,HWND ,int,int,int,int,int);
HWND Button(char*,HWND,int,int,int,int,int);
HWND DatePick(char*,HWND,int,int,int,int,int);

// *************************************************
//               User's Prototypes
// *************************************************

void FormLoad (void);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
	static WNDCLASS Wc;
	static MSG      Msg;
	// ***************************************
	strcpy(AppName,"DatePick");
	// ***************************************
	//   Scale Dialog Units To Screen Units
	// ***************************************
	BCX_GetDiaUnit = GetDialogBaseUnits();
	BCX_cxBaseUnit = LOWORD(BCX_GetDiaUnit);
	BCX_cyBaseUnit = HIWORD(BCX_GetDiaUnit);
	BCX_ScaleX     = BCX_cxBaseUnit/4;
	BCX_ScaleY     = BCX_cyBaseUnit/8;
	BCX_hInstance  = hInst;
	// ***************************************
	Wc.style = CS_HREDRAW|CS_VREDRAW;
	Wc.lpfnWndProc   =  WndProc;
	Wc.cbClsExtra    =  0;
	Wc.cbWndExtra    =  0;
	Wc.hInstance     =  hInst;
	Wc.hIcon         =  LoadIcon(NULL,IDI_WINLOGO);
	Wc.hCursor       =  LoadCursor(NULL,IDC_ARROW);
	Wc.hbrBackground =  (HBRUSH)(COLOR_BTNFACE+1);
	Wc.lpszMenuName  =  NULL;
	Wc.lpszClassName =  AppName;
	RegisterClass(&Wc);
	// ***************************************
	FormLoad();
	// ***************************************
	while(GetMessage(&Msg,NULL,0,0))
	{
		if(!IsWindow(GetActiveWindow()) ||
	     !IsDialogMessage(GetActiveWindow(),&Msg))
		{
			TranslateMessage(&Msg);
			DispatchMessage(&Msg);
		}
	}
	return Msg.wParam;
}




// *************************************************
//               Run Time Functions
// *************************************************


void Center (HWND hWnd)
{
	#define GSM GetSystemMetrics
	RECT  Rect;
	DWORD x,y;
	GetWindowRect(hWnd,&Rect);
	x=(GSM(SM_CXSCREEN)-(Rect.right-Rect.left))/2;
	y=(GSM(SM_CYSCREEN)-(Rect.bottom-Rect.top+GSM(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
	Show(hWnd);

}

HWND Form (char *Caption, int X, int Y, int W, int H)
{
	HWND  A;
	A=CreateWindow(AppName,Caption,
	WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_POPUP|WS_CAPTION|WS_SYSMENU,
	X*BCX_ScaleX,Y*BCX_ScaleY,(4+W)*BCX_ScaleX,
	(12+H)*BCX_ScaleY,NULL,(HMENU)NULL,BCX_hInstance,NULL);
	SendMessage(A,(UINT)WM_SETFONT,(WPARAM)GetStockObject
	(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	return A;
}

HWND Button(char*Text,HWND hWnd,int id,int X,int Y,int W,int H)
{
	HWND  A;
	A=CreateWindowEx(WS_EX_STATICEDGE,"button",Text,
	WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|WS_TABSTOP,
	X*BCX_ScaleX,Y*BCX_ScaleY,W*BCX_ScaleX,H*BCX_ScaleY,
	hWnd,(HMENU)id,BCX_hInstance,NULL);
	SendMessage(A,(UINT)WM_SETFONT,(WPARAM)GetStockObject
	(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	return A;
}



HWND Edit (char*Text,HWND hWnd,int id,int X,int Y,int W,int H)
{
	HWND  A;
	A=CreateWindowEx(0,"edit",Text,
	WS_CHILD|WS_VISIBLE|WS_BORDER|ES_WANTRETURN|WS_VSCROLL|
	ES_MULTILINE|ES_AUTOVSCROLL|ES_AUTOHSCROLL,
	X*BCX_ScaleX,Y*BCX_ScaleY,W*BCX_ScaleX,H*BCX_ScaleY,
	hWnd,(HMENU)id,BCX_hInstance,NULL);
	SendMessage(A,(UINT)WM_SETFONT,(WPARAM)GetStockObject
	(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	return A;
}



HWND DatePick(char*Text,HWND hWnd,int id,int X,int Y,int W,int H)
{
	HWND  A;
	RECT  rc;
	INITCOMMONCONTROLSEX  icex;
	icex.dwSize=sizeof(INITCOMMONCONTROLSEX);
	icex.dwICC=ICC_DATE_CLASSES;
	InitCommonControlsEx(&icex);
	A=CreateWindowEx(WS_EX_CLIENTEDGE,"SysDateTimePick32",0,
	WS_CHILD|WS_TABSTOP|WS_VISIBLE|DTS_LONGDATEFORMAT,
	X*BCX_ScaleX,Y*BCX_ScaleY,W*BCX_ScaleX,H*BCX_ScaleY,
	hWnd,(HMENU)id,BCX_hInstance,NULL);
	SendMessage(A,(UINT)WM_SETFONT,(WPARAM)GetStockObject
	(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	return A;
}


// *************************************************
//             User Subs and Functions
// *************************************************


void FormLoad (void)
{
	Form1=Form("DatePick!",1,1,99,100);
	Date1=DatePick("",Form1,999,3,3,95,10);
	Edit1=Edit("Click The Button",Form1,999,3,80,95,10);
	Butt1=Button("Update",Form1,123,3,30,95,15);
	Center(Form1);
	Show(Form1);
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg)
	{
	// *****************
	case WM_COMMAND:
	// *****************
		if(LOWORD(wParam)==123)
		{
			static char A[2048];
			memset(&A,0,sizeof(A));
			GetWindowText(Date1,A,80);
			SetWindowText(Edit1,A);
		}
		break;

	// *****************
	case WM_DESTROY:
	// *****************
		PostQuitMessage(0);
		return 0;
		break;
	}

	return DefWindowProc(hWnd,Msg,wParam,lParam);
}

